# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.create_bot_message_request import CreateBotMessageRequest
from ..model.create_bot_message_response import CreateBotMessageResponse


class BotMessage(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def create(self, request: CreateBotMessageRequest,
               option: Optional[RequestOption] = None) -> CreateBotMessageResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateBotMessageResponse = JSON.unmarshal(str(resp.content, UTF_8), CreateBotMessageResponse)
        response.raw = resp

        return response
