# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.batch_get_okr_request import BatchGetOkrRequest
from ..model.batch_get_okr_response import BatchGetOkrResponse


class Okr(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def batch_get(self, request: BatchGetOkrRequest, option: Optional[RequestOption] = None) -> BatchGetOkrResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchGetOkrResponse = JSON.unmarshal(str(resp.content, UTF_8), BatchGetOkrResponse)
        response.raw = resp

        return response
