# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.get_reserve_config_disable_inform_request import GetReserveConfigDisableInformRequest
from ..model.get_reserve_config_disable_inform_response import GetReserveConfigDisableInformResponse
from ..model.patch_reserve_config_disable_inform_request import PatchReserveConfigDisableInformRequest
from ..model.patch_reserve_config_disable_inform_response import PatchReserveConfigDisableInformResponse


class ReserveConfigDisableInform(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def get(self, request: GetReserveConfigDisableInformRequest,
            option: Optional[RequestOption] = None) -> GetReserveConfigDisableInformResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetReserveConfigDisableInformResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                         GetReserveConfigDisableInformResponse)
        response.raw = resp

        return response

    def patch(self, request: PatchReserveConfigDisableInformRequest,
              option: Optional[RequestOption] = None) -> PatchReserveConfigDisableInformResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchReserveConfigDisableInformResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                           PatchReserveConfigDisableInformResponse)
        response.raw = resp

        return response
